"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import ryax.action_builder.infrastructure.messaging.messages.action_builder_messages_pb2
import ryax.action_builder.infrastructure.messaging.messages.grpc_messages_pb2
import ryax.action_builder.infrastructure.messaging.messages.repository_messages_pb2
import typing

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class ActionBuilderStub:
    """Manage Ryax Action executions"""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Build: grpc.UnaryStreamMultiCallable[
        ryax.action_builder.infrastructure.messaging.messages.grpc_messages_pb2.BuildRequest,
        ryax.action_builder.infrastructure.messaging.messages.grpc_messages_pb2.BuildReply,
    ]

    CancelBuild: grpc.UnaryUnaryMultiCallable[
        ryax.action_builder.infrastructure.messaging.messages.repository_messages_pb2.ActionCancelBuild,
        ryax.action_builder.infrastructure.messaging.messages.action_builder_messages_pb2.ActionBuildCanceled,
    ]

class ActionBuilderAsyncStub:
    """Manage Ryax Action executions"""

    Build: grpc.aio.UnaryStreamMultiCallable[
        ryax.action_builder.infrastructure.messaging.messages.grpc_messages_pb2.BuildRequest,
        ryax.action_builder.infrastructure.messaging.messages.grpc_messages_pb2.BuildReply,
    ]

    CancelBuild: grpc.aio.UnaryUnaryMultiCallable[
        ryax.action_builder.infrastructure.messaging.messages.repository_messages_pb2.ActionCancelBuild,
        ryax.action_builder.infrastructure.messaging.messages.action_builder_messages_pb2.ActionBuildCanceled,
    ]

class ActionBuilderServicer(metaclass=abc.ABCMeta):
    """Manage Ryax Action executions"""

    @abc.abstractmethod
    def Build(
        self,
        request: ryax.action_builder.infrastructure.messaging.messages.grpc_messages_pb2.BuildRequest,
        context: _ServicerContext,
    ) -> typing.Union[collections.abc.Iterator[ryax.action_builder.infrastructure.messaging.messages.grpc_messages_pb2.BuildReply], collections.abc.AsyncIterator[ryax.action_builder.infrastructure.messaging.messages.grpc_messages_pb2.BuildReply]]: ...

    @abc.abstractmethod
    def CancelBuild(
        self,
        request: ryax.action_builder.infrastructure.messaging.messages.repository_messages_pb2.ActionCancelBuild,
        context: _ServicerContext,
    ) -> typing.Union[ryax.action_builder.infrastructure.messaging.messages.action_builder_messages_pb2.ActionBuildCanceled, collections.abc.Awaitable[ryax.action_builder.infrastructure.messaging.messages.action_builder_messages_pb2.ActionBuildCanceled]]: ...

def add_ActionBuilderServicer_to_server(servicer: ActionBuilderServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
